---
title: NavigatorPlugins.plugins
slug: Web/API/NavigatorPlugins/plugins
tags:
  - API
  - DOM
  - Navigator
  - NavigatorPlugins
  - Plugins
  - Property
  - Reference
---
<p>{{APIRef("HTML DOM")}}</p>

<p>Returns a {{DOMxRef("PluginArray")}} object, listing the {{DOMxRef("Plugin")}} objects describing the <a href="/en-US/docs/Mozilla/Add-ons/Plugins">plugins</a> installed in the application.</p>

<div class="note">
<p>In Firefox 29 and later, enumeration of the <code>navigator.plugins</code> array may be restricted as a privacy measure. Applications that must check for the presence of a browser plugin should query <code>navigator.plugins</code> or {{DOMxRef("navigator.mimeTypes")}} by exact name instead of enumerating the <code>navigator.plugins</code> array and comparing every plugin's name. This privacy change does not disable any plugins; it just hides some plugin names from enumeration.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <var>plugins</var> = navigator.plugins;
</pre>

<p><code>plugins</code> is {{DOMxRef("PluginArray")}} object used to access {{DOMxRef("Plugin")}} objects either by name or as a list of items.</p>

<p>The returned value is not a JavaScript array, but has the <code>length</code> property and supports accessing individual items using bracket notation (<code>plugins[2]</code>), as well as via <code>item(<var>index</var>)</code> and <code>namedItem(<em>"name"</em>)</code> methods.</p>

<h2 id="Examples">Examples</h2>

<p>The following example function returns the version of the Shockwave Flash plugin.</p>

<pre class="brush:js">function getFlashVersion() {
  var flash = navigator.plugins.namedItem('Shockwave Flash');
  if (typeof flash != 'object') {
    // flash is not present
    return undefined;
  }
  if(flash.version){
    return flash.version;
  } else {
    //No version property (e.g. in Chrome)
    return flash.description.replace(/Shockwave Flash /,"");
  }
}
</pre>

<p>The following example displays information about the installed plugin(s).</p>

<pre class="brush: js">var pluginsLength = navigator.plugins.length;

document.body.innerHTML = pluginsLength + " Plugin(s)&lt;br&gt;"
  + '&lt;table id="pluginTable"&gt;&lt;thead&gt;'
  +'&lt;tr&gt;&lt;th&gt;Name&lt;/th&gt;&lt;th&gt;Filename&lt;/th&gt;&lt;th&gt;description&lt;/th&gt;&lt;th&gt;version&lt;/th&gt;&lt;/tr&gt;'
  +'&lt;/thead&gt;&lt;tbody&gt;&lt;/tbody&gt;&lt;/table&gt;';

var table = document.getElementById('pluginTable');

for(var i = 0; i &lt; pluginsLength; i++) {
  let newRow = table.insertRow();
  newRow.insertCell().textContent = navigator.plugins[i].name;
  newRow.insertCell().textContent = navigator.plugins[i].filename;
  newRow.insertCell().textContent = navigator.plugins[i].description;
  newRow.insertCell().textContent = navigator.plugins[i].version?navigator.plugins[i].version:"";
}</pre>

<h2 id="Notes">Notes</h2>

<p>The {{DOMxRef("Plugin")}} object exposes a small interface for getting information about the various plugins installed in your browser. A list of plugins is also available by entering <code>about:plugins</code> in the browser's Location bar.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#dom-navigator-plugins', 'NavigatorPlugins.plugins')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.NavigatorPlugins.plugins")}}</p>

<p>In addition to listing each plugin as a pseudo-array by zero-indexed numeric properties, Firefox provides properties that are the plugin name directly on the <a href="/en-US/docs/Web/API/PluginArray">PluginArray</a> object.</p>
